Bug 853717 - genkey doesn't have option to use /dev/random; dog slow
genkey doesn't have option to use /dev/random; dog slow
Status: NEW
Product: Fedora
Classification: Fedora
Component: crypto-utils (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Joe Orton
Fedora Extras Quality Assurance
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-02 07:30 EDT by tlhackque
Modified: 2014-01-29 12:01 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description tlhackque 2012-09-02 07:30:44 EDT
Description of problem:
genkey uses the truerand library unconditionally to generate private keys.

Todays's CPUs contain hardware random number generators; many of us also use (e.g. USB dongles) to generate high-quality random numbers quickly.

genkey needs an option to use /dev/random (or /dev/hw_random) instead of truerand.

Also, note that the man page says "genkey generates random data for the private key using the truerand library and also by prompting the user for entry of
       random text."  I've never seen genkey prompt for random text.

While in the code, a --version qualifier would also be a good idea.

Version-Release number of selected component (if applicable):

crypto-utils.x86_64                     2.4.1-34.fc17                @anaconda-0


How reproducible:

Simply use genkey (e.g. genkey foo)

Steps to Reproduce:
1. genkey localhost
2. select a key size
3.  wait ... and wait ... and wait...

Note on a system with a USB dongle [EntropyKey]:
cat /proc/sys/kernel/random/entropy_avail
3968
cat /proc/sys/kernel/random/poolsize
4096
  
Yet a 2048 bit key takes minutes to generate.

Actual results:

Keys take minutes to generate on an unloaded system with hardware random generator.

Expected results:

Keys should be generated instantly (when entropy is available and /dev/random is specified as source)

Additional info:
Comment 1 Fedora End Of Life 2013-07-03 19:05:41 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Note You need to log in before you can comment on or make changes to this bug.